{=======================================================================================================================

  StringCopy

       .

========================================================================================================================

  :

  28.03.2019 [!]   (Embarcadero Delphi 10.3 Version 26.0.32429.4364).

========================================================================================================================
  Copyright 2019 TSK Developer Laboratory, Moscow.                                              Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: main.pas,v 1.2 2019/03/28 16:52:52 tsk Exp $
=======================================================================================================================}
unit main;

interface

uses  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, Vcl.ComCtrls,
      System.Math;

type
  TMainFM = class(TForm)
    edStr: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    edCount: TEdit;
    edIndex: TEdit;
    tbIndex: TTrackBar;
    udIndex: TUpDown;
    udCount: TUpDown;
    tbCount: TTrackBar;
    procedure FormCreate(Sender: TObject);
    procedure edStrChange(Sender: TObject);
    procedure edIndexChange(Sender: TObject);
    procedure tbIndexChange(Sender: TObject);
    procedure edCountChange(Sender: TObject);
    procedure tbCountChange(Sender: TObject);
  private   { Private declarations }
    procedure DoSelect;
    procedure IndexChange;
  public    { Public declarations }
  end;

var MainFM: TMainFM;

implementation

{$R *.dfm}
//======================================================================================================================
procedure TMainFM.FormCreate(Sender: TObject);
begin
  edStr.PasteFromClipboard;
end;
//======================================================================================================================
procedure TMainFM.edStrChange(Sender: TObject);
begin
  udIndex.Max       := Length( edStr.Text );
  udIndex.Position  := Min( udIndex.Position, udIndex.Max );
  tbIndex.Max       := udIndex.Max;
  IndexChange;
end;
//======================================================================================================================
procedure TMainFM.edIndexChange(Sender: TObject);
begin
  tbIndex.Position  := udIndex.Position;
  IndexChange;
end;
//======================================================================================================================
procedure TMainFM.tbIndexChange(Sender: TObject);
begin
  udIndex.Position := tbIndex.Position;
  IndexChange;
end;
//======================================================================================================================
procedure TMainFM.edCountChange(Sender: TObject);
begin
  tbCount.Position := udCount.Position;
  DoSelect;
end;
//======================================================================================================================
procedure TMainFM.tbCountChange(Sender: TObject);
begin
  udCount.Position := tbCount.Position;
  DoSelect;
end;
//======================================================================================================================
procedure TMainFM.IndexChange;
begin
  udCount.Max       := udIndex.Max - udIndex.Position;
  udCount.Position  := Min( udCount.Position, udCount.Max );
  tbCount.Max       := udCount.Max;
  tbCount.Position  := udCount.Position;
  DoSelect;
end;
//======================================================================================================================
procedure TMainFM.DoSelect;
begin
  edStr.SelStart  := udIndex.Position;
  edStr.SelLength := udCount.Position;
  SelectFirst;
end;
//======================================================================================================================
end.
